<?php

############################################################################################################################
#
#
#
#                    ###      ##      ##             #
#                  ##  ##   ##  ##    ##       #     #
#                  ##       ##  ##    ##           #####   ####
#                    ##     ##  ##    ##       #     #    #    #
#                      ##   ## ###    ##       #     #    #####
#                  ##  ##   ##  ##    ##       #     #    #
#                   ###       ##  #   ######   #      #    ####
#
#
#
#     Hierfr wird keine MySQL-Datenbank bentigt, sondern nur ein php5-fhiger Webspace.
#     Mit diesem grafischen Counter kannst du dir 3 verschiedende Werte anzeigen lassen.
#     Die Besucherzahl welche von der einstellbaren Reloadsperre beeinflusst wird. Die
#     einfache Anzahl der Seitenaufrufe oder die Zahl der User die sich zur Zeit auf
#     deiner Seite befinden.
#
#     Die mitgelieferten Bilder kannst du selber gegen andere austauschen. Sie mssen
#     dazu nur ersetzt werden und die gleichen Dateinamen haben. Jetzt musst du nur
#     noch kurz die folgende Konfiguration anpassen. Wenn mehrere Counter installiert
#     werden sollen, kann dieser Ordner unter einem anderen Namen nochmal hochgeladen
#     und die Tabellennamen umbenannt werden.
#
#     Um die Installation brauchst du dich nicht weiter zu kmmern. Der Counter erledigt
#     das von alleine. Je nach Serverkonfiguration kann es jedoch erforderlich sein, die
#     Datenbankdatei "counter.sqlite" mittels einem FTP-Programm auf chmod 666 zu setzen.
#     Sollte ein Fehler mit der Datenbank auftreten, wird der Counter es melden. Davon
#     ausgehend das der Ordner "sqlitecounter" im Hauptverzeichnis gespeichert wird,
#     kann das Bild mit diesem HTML-Code angezeigt werden:
#     <img src="sqlitecounter/counter.php" border="0" alt="Counter">
#
#
#
#     Copyright 2004 by www.numaek.de
#     Fr Support bitte auf http://www.numaek.de/forum/index.php melden
#
#
#
############################################################################################################################
#
#
#
#                         =====:: KONFIGURATION ANFANG ::=====



 define('DATENBANK',       'counter.sqlite');           // Name der Datenbankdatei

 define('TABELLE_COUNTER', 'counter');                  // Name der Tabelle fr Counter
 define('TABELLE_ONLINE',  'online');                   // Name der Tabelle fr Useronline
 define('TABELLE_WERTE',   'werte');                    // Name der Tabelle fr gespeicherte Werte

 define('SPEICHERZEIT',    '300');                      // Speicherzeit fr Useronline in Sekunden
 define('RELOAD',          '1800');                     // Speicherzeit fr Reloadsperre des Counters

 define('START_BESUCHE',   '0');                        // Startwert fr die Besucherzahl
 define('START_AUFRUFE',   '0');                        // Startwert fr die Seitenaufrufe

 define('STELLEN',         '6');                        // Gesamtstellen des Counters
 define('RAHMEN',          '2');                        // Rahmendicke um das Bild : 0 = kein Rahmen
 define('NULLEN',          'ja');                       // Den Wert nach links mit Nullen auffllen : ja oder nein
 define('FARBE',           '#000000');                  // Rahmenfarbe, bitte nur in hexadezimal-codiert

 define('FORMAT_IN',       'png');                      // Dateiendung der Counterbilder : gif, jpg oder png
 define('FORMAT_OUT',      'png');                      // Dateityp des erzeugten Bildes : gif, jpeg oder png

 define('ANZEIGE',         '2');                        // 1 = Besucher, 2 = Aufrufe, 3 = Useronline



#                          =====:: KONFIGURATION ENDE ::=====
#
#
#
############################################################################################################################
 # Ab hier besser nichts mehr verndern...

 ###########################################################################################################################

 error_reporting(0);

 // ##### Verbindung zur Datenbank herstellen #####
 if( ( $db = sqlite_open(DATENBANK, 0666, $sqliteerror) ) )
 {

	// ##### Installation berprfen #####
	$result1 = sqlite_fetch_array(sqlite_query("SELECT name FROM sqlite_master WHERE type = 'table' AND name = '" . TABELLE_COUNTER . "'", $db));
	if( $result1 == false )
	{
		sqlite_query("CREATE TABLE " . TABELLE_COUNTER . "(
				id INTERGER PRIMARY KEY,
				ip VARCHAR (50),
				time INT (11)
				)", $db);
		$msg    = '<html><body><br>SQLitecounter wurde installiert.<br><br>Scripturl = http://'.$_SERVER["SERVER_NAME"].$PHP_SELF.'<br><br></body></html>';
		$header = "Content-Type: text/html"; @mail("deinemudda@deinvadda.de", "SQLitecounter wurde installiert", $msg, $header);
	}
	$result2 = sqlite_fetch_array(sqlite_query("SELECT name FROM sqlite_master WHERE type = 'table' AND name = '" . TABELLE_ONLINE . "'", $db));
	if( $result2 == false )
	{
		sqlite_query("CREATE TABLE " . TABELLE_ONLINE . "(
				id INTERGER PRIMARY KEY,
				ip VARCHAR (50),
				time INT (11)
				)", $db);
	}
	$result3 = sqlite_fetch_array(sqlite_query("SELECT name FROM sqlite_master WHERE type = 'table' AND name = '" . TABELLE_WERTE . "'", $db));
	if( $result3 == false )
	{
		sqlite_query("CREATE TABLE " . TABELLE_WERTE . "(
				id INTERGER PRIMARY KEY,
				besuche INT (11),
				aufrufe INT (11)
				)", $db);

		sqlite_query("INSERT INTO " . TABELLE_WERTE . " (id, besuche, aufrufe) values ('1', '0', '0')", $db);
	}


	// ##### Fr die Rahmenfarbe Hex in RGB umwandeln #####
	$t  = substr(FARBE, -6);
	$t1 = hexdec("$t[0].$t[1]");
	$t2 = hexdec("$t[2].$t[3]");
	$t3 = hexdec("$t[4].$t[5]");
	define('FARBE_R', $t1);
	define('FARBE_G', $t2);
	define('FARBE_B', $t3);

	// ##### Counter #####
	$jetzt   = time();
	$userip  = $REMOTE_ADDR;

	$daten   = sqlite_fetch_array(sqlite_query("SELECT * FROM " . TABELLE_WERTE . " WHERE id = '1'", $db));
	$besuche = $daten['besuche'];
	$aufrufe = $daten['aufrufe'];

	sqlite_query("DELETE FROM " . TABELLE_COUNTER . " WHERE time < ( $jetzt - " . RELOAD . " )", $db);

	$meine_ip = sqlite_fetch_array(sqlite_query("SELECT * FROM " . TABELLE_COUNTER . " WHERE ip like '$userip'", $db));
	if( $meine_ip == false )
	{
		sqlite_query("INSERT INTO " . TABELLE_COUNTER . " (id, ip, time) values ('', '$userip', '$jetzt')", $db);
		$besuche++;
		$aufrufe++;
	} else
	  {
		sqlite_query("UPDATE " . TABELLE_COUNTER . " SET time = '$jetzt' WHERE ip like '$userip'", $db);
		$aufrufe++;
	  }

	sqlite_query("UPDATE " . TABELLE_WERTE . " SET besuche = '$besuche', aufrufe = '$aufrufe' WHERE id = '1'", $db);


	// ##### User online #####
	sqlite_query("DELETE FROM " . TABELLE_ONLINE . " WHERE time < ( $jetzt - " . SPEICHERZEIT . " )", $db);

	$meine_ip = sqlite_fetch_array(sqlite_query("SELECT * FROM " . TABELLE_ONLINE . " WHERE ip like '$userip'", $db));
	if( $meine_ip == false )
	{
		sqlite_query("INSERT INTO " . TABELLE_ONLINE . " (id, ip, time) values ('', '$userip', '$jetzt')", $db);
	} else
	  {
		sqlite_query("UPDATE " . TABELLE_ONLINE . " SET time = '$jetzt' WHERE ip like '$userip'", $db);
	  }


	// ##### Anzeigeart und auszugebenden Wert bestimmen #####
	if( ANZEIGE == 1 )
	{
		$zahl = $besuche + START_BESUCHE;
	} else
		if( ANZEIGE == 2 )
		{
			$zahl = $aufrufe + START_AUFRUFE;
		} else
			if( ANZEIGE == 3 )
			{
				$zahl = sqlite_num_rows(sqlite_query("SELECT id FROM " . TABELLE_ONLINE . "", $db));
			} else
			  {
				$zahl = $besuche + START_BESUCHE;
			  }

	$zahl = "$zahl";

	sqlite_close($db);

 } else
   {

	// ##### Datenbankfehler melden #####
	$bild_breite = 100;
	$bild_hoehe  = 30;
	$bild_font   = 3;
	$bild_text   = "DB - Error!";

	$bild        = imagecreate($bild_breite, $bild_hoehe);
	$schwarz     = imagecolorallocate($bild, 0, 0, 0);
	$rot         = imagecolorallocate($bild, 255, 0, 0);
	$text_breite = imagefontwidth($bild_font) * strlen($bild_text);
	$text_hoehe  = imagefontheight($bild_font);
	$text_x      = round( ( ( $bild_breite - $text_breite ) / 2), 1);
	$text_y      = round( ( ( $bild_hoehe  - $text_hoehe  ) / 2), 1);

	imagefill($bild, 2, 2, $schwarz);
	imagestring($bild, $bild_font, $text_x, $text_y, $bild_text, $rot);

	// ##### header modifizieren #####
	$bildformat = "image".FORMAT_OUT;
	header("Content-type: image/".FORMAT_OUT."");
	$bildformat($bild);
	imagedestroy($bild);

	DIE();

   }


 // ##### Zhlerstand anzeigen #####
 $infos   = getimagesize("0.".FORMAT_IN);
 $breite  = $infos[0];
 $hoehe   = $infos[1];
 $zeichen = strlen($zahl);
 $start   = 0 + RAHMEN;
 $stellen = STELLEN;
 $nullen  = STELLEN - $zeichen;

 $funktionsname = "imagecreatefrom".FORMAT_IN;

 if( $zeichen > STELLEN )
 {
	$stellen = $zeichen;
 }

 if( NULLEN == "ja" )
 {
	if( $nullen < 0 )
	{
		$nullen = 0;
	}
	$stellen = $zeichen + $nullen;
 } else
   {
	$nullen  = 0;
	$stellen = $zeichen;
   }

 // ##### Bild erzeugen #####
 $bild_x = ( $stellen * $breite ) + ( RAHMEN * 2 );
 $bild_y = $hoehe                 + ( RAHMEN * 2 );
 $bild   = imagecreate($bild_x, $bild_y);

 // ##### Rahmen #####
 $crf = imagecolorallocate($bild, FARBE_R, FARBE_G, FARBE_B);
 imagefill($bild, 1, 1, $crf);

 // ##### Mit Nullen auffllen #####
 if( NULLEN == "ja" )
 {
	for( $n = 0; $n < $nullen; $n++ )
	{
		$image = $funktionsname("0.".FORMAT_IN);
		ImageCopy($bild,$image,$start,0+RAHMEN,0,0,$breite,$hoehe);
		$start += $breite;
	}
 }

 // ##### Counterstand schreiben #####
 for( $w = 0; $w < $zeichen; $w++ )
 {
	$image = $funktionsname($zahl[$w].".".FORMAT_IN);
	ImageCopy($bild,$image,$start,0+RAHMEN,0,0,$breite,$hoehe);
	$start += $breite;
 }

 // ##### header modifizieren #####
 $bildformat = "image".FORMAT_OUT;
 header("Content-type: image/".FORMAT_OUT."");
 $bildformat($bild);
 imagedestroy($bild);

?>